
#      Create a title:                  > set title "Force-Deflection Data" 
#      Put a label on the x-axis:       > set xlabel "Deflection (meters)"
#      Put a label on the y-axis:       > set ylabel "Force (kN)"
#      Change the x-axis range:         > set xrange [0.001:0.005]
#      Change the y-axis range:         > set yrange [20:500]
#      Have Gnuplot determine ranges:   > set autoscale
#      Move the key:                    > set key 0.01,100
#      Delete the key:                  > unset key
#      Put a label on the plot:         > set label "yield point" at 0.003, 260 
#      Remove all labels:               > unset label
#      Plot using log-axes:             > set logscale
#      Plot using log-axes on y-axis:   > unset logscale; set logscale y 
#      Change the tic-marks:            > set xtics (0.002,0.004,0.006,0.008)
#      Return to the default tics:      > unset xtics; set xtics auto

set title "Coordinates vs time"
set ylabel "x theta"
set xlabel "t"
set grid

set term X11 1
set output

plot "state.dat" using ($1):($2) title "x", "state.dat" using ($1):($3)  title "theta"

set term postscript eps color
set output "coordinates.eps"

plot "state.dat" using ($1):($2) title "x", "state.dat" using ($1):($3)  title "theta"

set term X11 2
set output

set title "Velocities vs time"
set ylabel "dx dtheta"

plot "state.dat" using ($1):($4) title "dx", "state.dat" using ($1):($5)  title "dtheta"

set term postscript eps color
set output "velocities.eps"

plot "state.dat" using ($1):($4) title "dx", "state.dat" using ($1):($5)  title "dtheta"

set term X11 3
set output

set title "Accelerations vs time"
set ylabel "ddx ddtheta"

plot "state.dat" using ($1):($6) title "ddx", "state.dat" using ($1):($7)  title "ddtheta"

set term postscript eps color
set output "accelerations.eps"

plot "state.dat" using ($1):($6) title "ddx", "state.dat" using ($1):($7)  title "ddtheta"

set term X11 4
set output

set title "Forces vs time"
set ylabel "Fgbz Fbpx Fbpz"

plot "state.dat" using ($1):($18) title "x", "state.dat" using ($1):($22)  title "theta","state.dat" using ($1):($24)  title "theta"

set term postscript eps color
set output "Forces.eps"

plot "state.dat" using ($1):($18) title "x", "state.dat" using ($1):($22)  title "theta","state.dat" using ($1):($24)  title "theta"
