#ifndef TENSOR3D_H
#define TENSOR3D_H

#include "Matrix.h"
#include "Base.h"
#include "Vector3D.h"

using GiNaC::ex;
using GiNaC::relational;
using GiNaC::matrix;
using std::ostream;
using std::string;


	class Tensor3D : public Matrix{

		//Atributes

		Base * base;

	private:

		//Private methods

		void init ( string name , matrix mat , Base * base , System * system );
		static Tensor3D Operations ( const Tensor3D & Tensor3DA , const Tensor3D & Tensor3DB , const int flag );

	public:

		//Constructors

		Tensor3D () ;
		Tensor3D ( Matrix , Base * );
		Tensor3D ( string name , Matrix * mat , Base * base );
		Tensor3D ( string name , ex exp1 , ex exp2 , ex exp3 , ex exp4 , ex exp5 , ex exp6 , ex exp7 , ex exp8 , ex exp9 , Base * base );
		Tensor3D ( string name , Matrix mat , Base * base , System * sysmte );
		Tensor3D ( string name , ex exp1 , ex exp2 , ex exp3 , ex exp4 , ex exp5 , ex exp6 , ex exp7 , ex exp8 , ex exp9 , Base * base , System * system );

		//Access methods

		void set_Base ( Base * new_base );
		Base * get_Base ( void );

		//Public methods

		Tensor3D subs  ( relational relation );

		//Operations

		friend Tensor3D operator + ( const Tensor3D & Tensor3DA , const Tensor3D & Tensor3DB );
		friend Tensor3D operator - ( const Tensor3D & Tensor3DA , const Tensor3D & Tensor3DB );
		friend Tensor3D operator * ( const Tensor3D & Tensor3DA , const Tensor3D & Tensor3DB );
		friend Vector3D operator * ( const Tensor3D & Tensor3DA , Vector3D & Vector3DA );
		friend ostream & operator << ( ostream & os , const Tensor3D & Tensor3DA );

		//Destructor

		~Tensor3D ( void );
	};

#endif // TENSOR3D_H
